<template>
  <div>
    <div>
      <el-form :inline="true" class="orderform" size="mini">
        <el-row>
          <el-form-item>
            <el-input v-model="tag" style="width: 250px" placeholder="请输入菜单名称" class="search_tag" clearable/>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="btn_search()"><i class="el-icon-search"/> 查询</el-button>
            <el-button @click="btn_clear()"><i class="el-icon-remove-outline"/> 重置</el-button>
            <el-button type="primary" icon="el-icon-plus" @click="addMenu">添加</el-button>
          </el-form-item>
        </el-row>
      </el-form>
      <el-table
        ref="multipleTable"
        :data="tableData"
        :highlight-current-row="true"
        border>
        <el-table-column
          prop="id"
          label="编号"/>
        <el-table-column
          prop="menuName"
          label="菜单名称"/>
        <el-table-column
          prop="menuUrl"
          label="菜单链接"/>
        <el-table-column
          prop="description"
          label="备注"/>
        <el-table-column
          fixed="right"
          label="操作">
          <template slot-scope="scope">
            <el-button type="text" @click="editMenu(scope.row)">编辑</el-button>
            <el-button type="text" @click="deleteMenuConfirm(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="mydiv">
        <el-pagination
          :current-page.sync="pageNo"
          :page-sizes="[10, 50, 100, 300,1000]"
          :page-size="pageSize"
          :total="totalDataNumber"
          layout="sizes,total, prev, pager, next"
          class="table-pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>

    </div>
    <!--弹出框-->
    <el-dialog :visible.sync="dialogFormVisiable" title="添加菜单">
      <el-form :model="addForm" :rules="rules" label-width="100px" >
        <el-form-item label="菜单名称" prop="menuName">
          <el-input v-model="addForm.menuName" placeholder="请输入菜单名称" size="mini"/>
        </el-form-item>
        <el-form-item label="菜单链接" prop="menuUrl">
          <el-input v-model="addForm.menuUrl" placeholder="请输入菜单链接" size="mini"/>
        </el-form-item>
        <el-form-item label="描述">
          <el-input v-model="addForm.description" rows="3" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="addMenuCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="addMenuSubmit">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogModifyVisiable" title="修改菜单">
      <el-form :model="modifyForm" :rules="rules" label-width="100px">
        <el-form-item label="菜单名称" prop="menuName">
          <el-input v-model="modifyForm.menuName" placeholder="请输入菜单名称" size="mini"/>
        </el-form-item>
        <el-form-item label="菜单链接">
          <el-input v-model="modifyForm.menuUrl" placeholder="请输入菜单链接" size="mini"/>
        </el-form-item>
        <el-form-item label="描述">
          <el-input v-model="modifyForm.description" rows="3" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="updateMenuCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="updateMenu">确 定</el-button>
      </div>
    </el-dialog>
    <!-- 点击删除按钮，删除确认框-->
    <el-dialog
      :visible.sync="deleteDialogVisible"
      title="提示"
      width="30%">
      <span>确定删除选择的菜单? </span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="deleteDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="handleClickDelete">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import axios from 'axios'

export default {
  name: 'Index',
  data() {
    return {
      rules: {
        menuName: [{ required: true, message: '请输入菜单名称', trigger: 'blur' }],
        menuUrl: [{ required: true, message: '请输入菜单链接', trigger: 'blur' }]
      },
      tag: '',
      allData: [], // 所有前端分页数据
      tableData: [], // 表格数据 仅展示当前页的数据
      pageNo: 1, // 当前页数
      totalDataNumber: 0, // 总记录数
      pageSize: 10,
      formLabelWidth: '100px', // 弹出框form宽
      dialogAuthVisiable: false,
      dialogFormVisiable: false,
      dialogModifyVisiable: false,
      deleteDialogVisible: false,
      addForm: {
        menuName: '',
        menuUrl: '',
        description: ''
      },
      modifyForm: {
        id: '',
        menuName: '',
        menuUrl: '',
        description: ''
      },
      deleteMenuId: ''
    }
  },
  created() {
    this.btn_search()
  },
  mounted() {
  },
  methods: {
    btn_search() {
      const vm = this
      axios.get(process.env.BASE_API + '/menu/list', {
        params: {
          tag: this.tag
        }
      }).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
          vm.totalDataNumber = 0
          vm.allData = []
          vm.tableData = []
        } else {
          vm.totalDataNumber = parseInt(obj.total)
          if (vm.totalDataNumber > 0) {
            vm.allData = obj.data
            vm.tableData = obj.data.slice(0, vm.pageSize)
          } else {
            vm.allData = []
            vm.tableData = []
          }
        }
      }).catch(function(error) {
        alert(error)
      })
    },
    btn_clear() {
      this.tag = ''
      this.btn_search()
    },
    handleCurrentChange() {
      this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
    },
    addMenu() {
      this.dialogFormVisiable = true
    },
    addMenuCancel() {
      this.dialogFormVisiable = false
      this.clearForm()
    },
    clearForm() {
      this.addForm.menuName = ''
      this.addForm.menuUrl = ''
      this.addForm.description = ''
    },
    addMenuSubmit() {
      const vm = this
      var params = new URLSearchParams()
      if (vm.addForm.menuName === '') {
        this.$message.error('请输入菜单名称')
        return
      }
      if (vm.addForm.menuUrl === '') {
        this.$message.error('请输入菜单链接')
        return
      }
      params.append('menuName', vm.addForm.menuName)
      params.append('menuUrl', vm.addForm.menuUrl)
      params.append('description', vm.addForm.description)
      axios.post(process.env.BASE_API + '/menu/create', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.clearForm()
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.dialogFormVisiable = false
    },
    editMenu(row) {
      this.dialogModifyVisiable = true
      this.modifyForm = row
    },
    updateMenuCancel() {
      this.dialogModifyVisiable = false
      this.modifyForm = ''
      this.btn_search()
    },
    updateMenu() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.modifyForm.id)
      params.append('menuName', vm.modifyForm.menuName)
      params.append('menuUrl', vm.modifyForm.menuUrl)
      params.append('description', vm.modifyForm.description)
      axios.post(process.env.BASE_API + '/menu/update', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
        vm.modifyForm = ''
      }).catch(function(error) {
        alert(error)
      })
      this.dialogModifyVisiable = false
    },
    deleteMenuConfirm(row) {
      this.deleteMenuId = row.id
      this.deleteDialogVisible = true
    },
    handleClickDelete() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.deleteMenuId)
      axios.post(process.env.BASE_API + '/menu/delete', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.deleteDialogVisible = false
    },
    setMenuAuth(id) {
    }
  }
}
</script>

<style scoped>
  .orderform {
    padding-top: 20px;
    padding-left: 10px;
    padding-right: 10px;
  }

  .mydiv {
    float: right;
    margin-right: 10px;
  }
</style>
